unit Stange;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dglOpenGL, Mesh;

type

  { TStange }

  TStange = class(TObject)
  private
    Mesh: TMesh;
    ListIndex: GLuint;
  public
    constructor Create(d, l: single);
    destructor Destroy; override;
    procedure Draw;
  end;

implementation

{ TStange }

constructor TStange.Create(d, l: single);
var
  d2: single;
begin
  Mesh := TMesh.Create;
  ListIndex := glGenLists(1);

  glNewList(ListIndex, GL_COMPILE);
  d2 := d / 2;

  glBegin(GL_QUADS);
  glColor3f(1, 0.3, 0.3);
  glVertex3f(d2, -d2, 0);
  glVertex3f(l - d2, -d2, 0);
  glVertex3f(l - d2, d2, 0);
  glVertex3f(d2, d2, 0);
  glEnd();

  glTranslatef(0, 0, -0.01);
  Mesh.col1 := vec3(0.7, 0.0, 0.0);
  Mesh.col2 := vec3(1.0, 0.1, 0.1);
  Mesh.Disk(d / 2, d);

  glTranslatef(l, 0.0, 0.0);
  Mesh.col1 := vec3(0.7, 0.0, 0.0);
  Mesh.col2 := vec3(1.0, 0.1, 0.1);
  Mesh.Disk(d / 2, d);

  glEndList;
end;

destructor TStange.Destroy;
begin
  Mesh.Free;
  glDeleteLists(ListIndex, 1);
  inherited Destroy;
end;

procedure TStange.Draw;
begin
  glPushMatrix;
  glCallList(ListIndex);
  glPopMatrix;
end;

end.
