unit unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, OpenGLContext, dglOpenGL, LCLType, StdCtrls, Math,
  Mesh, Rad, Stange;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    OpenGLControl1: TOpenGLControl;
    Panel1: TPanel;
    Timer1: TTimer;
    ToggleBox1: TToggleBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure OpenGLControl1Paint(Sender: TObject);
    procedure OpenGLControl1Resize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToggleBox1Change(Sender: TObject);
  public
    Mesh: TMesh;
    Rad: TRad;
    PleuelSchwinge1, PleuelSchwinge2, Schubstange, Pleuel, Zylinder: TStange;
    speed, winkel: single;
    procedure BackGround;
  end;

var
  Form1: TForm1;

implementation

const
  radR = 0.5;
  l = 1.2;
  SchwingeL = l / 2.3;
  SchwingePleuelL = l * 0.95;

{ TForm1 }

function GetAlpha(a, b, c: single): single;
begin
  Result := arccos((-sqr(a) + sqr(b) + sqr(c)) / (2 * b * c));
  Result := Result / pi * 180;
end;

function GetBeta(a, b, c: single): single;
begin
  Result := arccos((-sqr(b) + sqr(a) + sqr(c)) / (2 * a * c));
  Result := Result / pi * 180;
end;

function GetGama(a, b, c: single): single;
begin
  Result := arccos((-sqr(c) + sqr(a) + sqr(b)) / (2 * a * b));
  Result := Result / pi * 180;
end;

procedure TForm1.BackGround;
begin
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity();

  glBegin(GL_QUADS);
  glColor3f(0.4, 0.2, 0.3);
  glVertex3f(-1.0, -1.0, 0.999);
  glColor3f(0.45, 0.25, 0.3);
  glVertex3f(+1.0, -1.0, 0.999);
  glColor3f(0.4, 0.25, 0.53);
  glVertex3f(+1.0, +1.0, 0.999);
  glColor3f(0.45, 0.2, 0.35);
  glVertex3f(-1.0, +1.0, 0.999);
  glEnd();

  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  OpenGLControl1.Repaint;
end;

procedure TForm1.ToggleBox1Change(Sender: TObject);
begin
  Timer1.Enabled := ToggleBox1.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  InitOpenGL;
  OpenGLControl1.MakeCurrent;
  ReadExtensions;
  ReadImplementationProperties;

  Mesh := TMesh.Create;
  Rad := TRad.Create(radR);

  Schubstange := TStange.Create(radR / 8, 1.2);
  Pleuel := TStange.Create(radR / 8, l);
  Zylinder := TStange.Create(radR / 8, l / 2);

  PleuelSchwinge1 := TStange.Create(radR / 48, SchwingePleuelL);
  PleuelSchwinge2 := TStange.Create(radR / 48, SchwingeL);
  speed := 3.01;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Rad.Free;
  Mesh.Free;
  Schubstange.Free;
  Pleuel.Free;
  Zylinder.Free;
  PleuelSchwinge1.Free;
  PleuelSchwinge2.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  speed *= 1.1;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  speed /= 1.1;
end;

procedure TForm1.OpenGLControl1Paint(Sender: TObject);
var
  p, zx, zy,
  alpha, beta, gama,
  w, a, b, c: single;
begin
  glClearColor(0.4, 0.2, 0.3, 1.0);
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glEnable(GL_DEPTH_TEST);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  BackGround;

  //  glScalef(1.5, 1.5, 1.5);
  glTranslatef(-1.0, 0.0, 0.0);

  glColor3f(1, 1, 1);
  Mesh.Arc(radR * 1.2, radR * 1.4, 90, 180.0); // deutet eine Schwinge an
  glColor3f(1, 0.1, 1);
  Mesh.Arc(radR * 1.4, radR * 1.6, -30, 30); // deutet eine Schwinge an


  winkel += speed;
  if winkel > 360 then begin
    winkel -= 360;
  end;
  Rad.Draw(winkel);
  glTranslatef(1.2, 0.0, 0.0);
  Rad.Draw(winkel);

  glPushMatrix;
  glTranslatef(0, 0, -0.03);
  zx := cos(winkel / 180.0 * Pi) * radR * 0.65;
  zy := sin(winkel / 180.0 * Pi) * radR * 0.65;

  glTranslatef(zx, zy, 0);

  glPushMatrix;
  glRotatef(180.0, 0.0, 0.0, 1.0);
  //  Schubstange.Draw;
  glPopMatrix;

  glRotatef(arcsin(-zy / l) / Pi * 180.0, 0.0, 0.0, 1.0);
  //  glRotatef(arccos(-zx / l) / Pi * 180.0, 0.0, 0.0, 1.0); // senkrecht
  //  Pleuel.Draw;
  glPopMatrix;

  glPushMatrix;
  p := sqrt(sqr(l) - sqr(zy)) + zx;
  glTranslatef(p, 0.0, 0.0);
  //  Zylinder.Draw;
  glPopMatrix;

  glPushMatrix;
  if winkel < 180.0 then begin
    glRotatef(winkel / 10, 0.0, 0.0, 1.0);
  end else begin
    glRotatef(180.0 / 10 - (winkel / 10 - 180.0 / 10), 0.0, 0.0, 1.0);
  end;
  Mesh.Arc(radR * 1.2, radR * 1.4, 0, 60); // deutet eine Schwinge an
  glPopMatrix;

  // --- Schwinge ---

  // Schwinge links

  zx := cos(winkel / 180.0 * Pi) * radR * 0.85;
  zy := sin(winkel / 180.0 * Pi) * radR * 0.85;

  //  ShowMessage(FloatToStr(GetAlpha(a, b, c)) + '   ' + FloatToStr(GetBeta(a, b, c)) + '   ' + FloatToStr(GetGama(a, b, c)));

  a := SchwingeL;
  b := SchwingePleuelL;
  c := sqrt(sqr(zy) + sqr(l - zx));

  alpha := GetAlpha(a, b, c);
  beta := GetBeta(a, b, c);

  w := arcsin(-zy / (l - zx)) / Pi * 180.0;

  Caption := FloatToStr(w) + '  ' + FloatToStr(c);


  glPushMatrix;

  glTranslatef(zx, zy, 0);
  glRotatef(alpha + w, 0.0, 0.0, 1.0);
  PleuelSchwinge1.Draw;

  glPopMatrix;

  // Schwinge rechts


  glPushMatrix;

  glTranslatef(l, 0, 0);
  glRotatef(180.0 - beta + w, 0.0, 0.0, 1.0);
  PleuelSchwinge2.Draw;

  glPopMatrix;


  OpenGLControl1.SwapBuffers;
end;

procedure TForm1.OpenGLControl1Resize(Sender: TObject);
begin
  with OpenGLControl1 do begin
    glViewport(0, 0, Width, Height);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glScalef(Height / Width, 1.0, 1.0);
  end;
end;


initialization

  {$I unit1.lrs}

end.
